/* c-irrlicht --- C bindings for Irrlicht Engine

   Copyright (C) 2019 Javier Sancho <jsf@jsancho.org>

   This file is part of c-irrlicht.

   c-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   c-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht.  If not, see
   <http://www.gnu.org/licenses/>.
*/

#ifndef __C_IRR_I_VIDEO_DRIVER_H_INCLUDED__
#define __C_IRR_I_VIDEO_DRIVER_H_INCLUDED__

#include "ITexture.h"
#include "SColor.h"
#include "SExposedVideoData.h"
#include "rect.h"

typedef void irr_video_IVideoDriver;

#ifdef __cplusplus
extern "C" {
#endif

  bool
  irr_video_IVideoDriver_beginScene(irr_video_IVideoDriver* driver,
                                    bool backBuffer,
                                    bool zBuffer,
                                    const irr_video_SColor* color,
                                    irr_video_SExposedVideoData* videoData,
                                    const irr_core_rect_s32* sourceRect);

  bool
  irr_video_IVideoDriver_endScene(irr_video_IVideoDriver* driver);

  irr_video_ITexture*
  irr_video_IVideoDriver_getTexture(irr_video_IVideoDriver* driver,
                                    const char* filename);

#ifdef __cplusplus
}
#endif

#endif
