/* c-irrlicht --- C bindings for Irrlicht Engine

   Copyright (C) 2019 Javier Sancho <jsf@jsancho.org>

   This file is part of c-irrlicht.

   c-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   c-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht.  If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include "IAnimatedMeshSceneNode.h"

extern "C" {
  void
  irr_scene_IAnimatedMeshSceneNode_setMaterialFlag(irr_scene_IAnimatedMeshSceneNode* node,
                                                   irr_video_E_MATERIAL_FLAG flag,
                                                   bool newvalue)
  {
    ((irr::scene::IAnimatedMeshSceneNode*)node)->setMaterialFlag((irr::video::E_MATERIAL_FLAG)flag,
                                                                 newvalue);
  }

  void
  irr_scene_IAnimatedMeshSceneNode_setMaterialTexture(irr_scene_IAnimatedMeshSceneNode* node,
                                                      u_int32_t textureLayer,
                                                      irr_video_ITexture* texture)
  {
    ((irr::scene::IAnimatedMeshSceneNode*)node)->setMaterialTexture(textureLayer,
                                                                    (irr::video::ITexture*)texture);
  }

  bool
  irr_scene_IAnimatedMeshSceneNode_setMD2Animation(irr_scene_IAnimatedMeshSceneNode* node,
                                                   irr_scene_EMD2_ANIMATION_TYPE anim)
  {
    return ((irr::scene::IAnimatedMeshSceneNode*)node)->setMD2Animation((irr::scene::EMD2_ANIMATION_TYPE)anim);
  }

}
