/* c-irrlicht --- C bindings for Irrlicht Engine

   Copyright (C) 2019 Javier Sancho <jsf@jsancho.org>

   This file is part of c-irrlicht.

   c-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   c-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht.  If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include <wchar.h>
#include "IrrlichtDevice.h"

extern "C" {
  irr_gui_IGUIEnvironment*
  irr_IrrlichtDevice_getGUIEnvironment(irr_IrrlichtDevice* device)
  {
    return ((irr::IrrlichtDevice*)device)->getGUIEnvironment();
  }

  irr_scene_ISceneManager*
  irr_IrrlichtDevice_getSceneManager(irr_IrrlichtDevice* device)
  {
    return ((irr::IrrlichtDevice*)device)->getSceneManager();
  }

  irr_video_IVideoDriver*
  irr_IrrlichtDevice_getVideoDriver(irr_IrrlichtDevice* device)
  {
    return ((irr::IrrlichtDevice*)device)->getVideoDriver();
  }

  void
  irr_IrrlichtDevice_setWindowCaption(irr_IrrlichtDevice* device,
                                      const char* text)
  {
    wchar_t *wtext = (wchar_t*)malloc((strlen(text) + 1) * sizeof(wchar_t));
    mbsrtowcs(wtext, &text, strlen(text) + 1, NULL);
    ((irr::IrrlichtDevice*)device)->setWindowCaption(wtext);
  }

  int
  irr_IrrlichtDevice_run(irr_IrrlichtDevice* device)
  {
    return ((irr::IrrlichtDevice*)device)->run() ? 1 : 0;
  }

  int
  irr_IrrlichtDevice_drop(irr_IrrlichtDevice* device)
  {
    return ((irr::IrrlichtDevice*)device)->drop() ? 1 : 0;
  }
}
